/*****************************************************************************
 * vlvc.h: VLVC access module headers
 *****************************************************************************
 * Copyright (C) 2005 - 2008 the VLVC team
 * $Id: vlvc.h
 *
 * Authors: Julien ARNAUD <arnaud_j@epitech.net>
 *          Julien CUPILLARD <cupill_j@epitech.net>
 *          Thomas DELON <delon_t@epitech.net>
 *          Arnaud DEREDEC <derede_a@epitech.net>
 *          Florian GUSTIN <gustin_f@epitech.net>
 *          Sylvestre HO TAM CHAY <ho-tam_s@epitech.net>
 *          Romain LAVOCAT <lavoca_r@epitech.net>
 *          William LIENARD <lienar_w@epitech.net>
 *          Guillaume MARTIN <martin_u@epitech.net>
 *          Florent NGUYEN <nguyen_c@epitech.net>
 *          Julien PASSERI <passer_j@epitech.net>
 *          Mathavarajan SUGUMARAN <suguma_m@epitech.net>
 *          David YU <yu_d@epitech.net
 *
 * This software has been written in EPITECH <http://www.epitech.net>
 * EPITECH is computer science school in Paris - FRANCE -
 * under the direction of Flavien Astraud <http://www.epita.fr/~flav>,
 * Jerome Landrieu and Launiau Severin.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/

/*********
 * Texts *
 *********/
#define SERVER_MODE_TEXT N_( "Server mode" )
#define SERVER_MODE_LONGTEXT N_( "Check if you host the conference.\n"\
   "Uncheck if you join a conference" )

#define STANDALONE_MODE_TEXT N_( "Standalone (Cannot be used with GUI)" )
#define STANDALONE_MODE_LONGTEXT N_( "Use this option to use VLVC in standalone mode.\n"\
   "In standalone mode, only launched using a script, VLVC won't display any window." )

#define HOST_IP_ADDR_TEXT N_( "IP Address/Domain name" )
#define HOST_IP_ADDR_LONGTEXT N_( "If in client mode, enter the server "\
   "IP address or domain name.\nIf in server mode, enter the IP address or domain name to bind." )

#define HOST_PORT_TEXT N_( "Server port" )
#define HOST_PORT_LONGTEXT  N_( "If in client mode, enter the server "\
   "port.\nIf in server mode, enter the port to bind" )

#define FIRST_CLIENT_PORT_TEXT N_( "First streaming port" )
#define FIRST_CLIENT_PORT_LONGTEXT  N_( "This is the port used to receive "\
   "videos from the other participants.\nOne port per client will be used, starting from this one." )

#define HOST_USERNAME_TEXT N_( "Username" )
#define HOST_USERNAME_LONGTEXT N_( "Choose a username" )

#define HOST_DESCRIPTION_TEXT N_( "Description" )
#define HOST_DESCRIPTION_LONGTEXT N_( "Choose a description" )

#define PASSWORD_TEXT N_( "Password" )
#define PASSWORD_LONGTEXT N_( "Set a password" )

#define VDEV_TEXT N_( "Video device name" )
#define VDEV_LONGTEXT N_( "Name of the video device to use." )

#define ADEV_TEXT N_( "Audio device name" )
#define ADEV_LONGTEXT N_( "Name of the Audio device to use." )

#define INPUT_MRL_TEXT N_( "MRL of input device" )
#define INPUT_MRL_LONGTEXT N_( "input MRL to use. " )

#define VCODEC_TEXT N_( "Video codec to use" )
#define VCODEC_LONGTEXT N_( "Select the video codec you want to use" )

#define VBITRATE_TEXT N_( "Video bitrate to use" )
#define VBITRATE_LONGTEXT N_( "Select the video bitrate you want to apply" )

#define ACODEC_TEXT N_( "Audio codec to use" )
#define ACODEC_LONGTEXT N_( "Select the audio codec you want to use" )

#define ABITRATE_TEXT N_( "Audio bitrate to use" )
#define ABITRATE_LONGTEXT N_( "Select the audio bitrate you want to apply" )

#define CONFERENCE_MODE_TEXT N_( "Conference mode" )
#define CONFERENCE_MODE_LONGTEXT N_( "Select the videoconference mode\n" \
    "Used in server mode only" )

#define NETWORK_PROTOCOL_TEXT N_( "Network protocol" )
#define NETWORK_PROTOCOL_LONGTEXT N_( "Select the network protocol" )

#define VIDEO_CAPTURE_SIZE_TEXT N_( "Video capture size" )
#define VIDEO_CAPTURE_SIZE_LONGTEXT N_( "Select the video capture size\n" \
    "Note that your camera may not support all of these. Change\n" \
    "it if a problem occur." )

#define VIDEO_SCALE_TEXT N_( "Video scale" )
#define VIDEO_SCALE_LONGTEXT N_( "Select the video scale\n" \
    "This scale will be applied to the video capture size\n" \
    "Used to lower the video size mainly to save bandwidth" )

#define BUFFER_LEVEL_TEXT N_( "Network configuration" )
#define BUFFER_LEVEL_LONGTEXT N_( "Select the network configuration\n" \
    "Used to modify the buffer settings of VLC\n" \
    "It will affect latency and video/audio quality\n" \
    "Let \"Default\" to use VLC settings" )

#define FORCE_CODECS_TEXT N_( "Force clients to use the same codecs as the server" )
#define FORCE_CODECS_LONGTEXT N_( "Used by the server to force the clients to use the same codecs as him" )

#define FIX_OVERLAY_TEXT N_( "Fix display problems" )
#define FIX_OVERLAY_LONGTEXT N_( "Check this box if there is a display problem with the video windows" )

#define MULTICAST_MODE_TEXT "Multicast"
#define MULTICAST_MODE_LONGTEXT N_( "Use multicast if possible, else, automatically switch to unicast" )

/*******************
 * Variables Names *
 *******************/

#define VLVC_VAR_SERVER_MODE "vlvc-server-mode"
#define VLVC_VAR_STANDALONE_MODE "vlvc-standalone-mode"
#define VLVC_VAR_IP "vlvc-ip"
#define VLVC_VAR_PORT "vlvc-port"
#define VLVC_VAR_FIRST_CLIENT_PORT "vlvc-first-client-port"
#define VLVC_VAR_INPUT_MRL "vlvc-input-mrl"
#define VLVC_VAR_VIDEO_DEVICE "vlvc-vdev"
#define VLVC_VAR_AUDIO_DEVICE "vlvc-adev"
#define VLVC_VAR_USERNAME "vlvc-username"
#define VLVC_VAR_DESCRIPTION "vlvc-description"
#define VLVC_VAR_VCODEC "vlvc-video-codec"
#define VLVC_VAR_ACODEC "vlvc-audio-codec"
#define VLVC_VAR_VBITRATE "vlvc-video-bitrate"
#define VLVC_VAR_ABITRATE "vlvc-audio-bitrate"
#define VLVC_VAR_CONFERENCE_MODE "vlvc-conference-mode"
#define VLVC_VAR_NETWORK_PROTOCOL "vlvc-network-protocol"
#define VLVC_VAR_VIDEO_CAPTURE_SIZE "vlvc-video-capture-size"
#define VLVC_VAR_VIDEO_SCALE "vlvc-video-scale"
#define VLVC_VAR_BUFFER_LEVEL "vlvc-buffer-level"
#define VLVC_VAR_FORCE_CODECS "vlvc-force-codecs"
#define VLVC_VAR_FIX_OVERLAY "vlvc-fix-overlay"
#define VLVC_VAR_PASSWORD "vlvc-password"
#define VLVC_VAR_MULTICAST_MODE "vlvc-multicast-mode"

/****************************
 * Variables default values *
 ****************************/

#define VLVC_VAR_SERVER_MODE_DEFAULT VLC_FALSE
#define VLVC_VAR_STANDALONE_MODE_DEFAULT VLC_FALSE
#define VLVC_VAR_FIX_OVERLAY_DEFAULT VLC_TRUE
#define VLVC_VAR_IP_DEFAULT ""
#define VLVC_VAR_PORT_DEFAULT 4242
#define VLVC_VAR_FIRST_CLIENT_PORT_DEFAULT 1234
#if defined (WIN32)
# define VLVC_VAR_INPUT_MRL_DEFAULT "dshow://"
# define VLVC_VAR_VIDEO_DEVICE_DEFAULT ""
# define VLVC_VAR_AUDIO_DEVICE_DEFAULT ""
#else
# define VLVC_VAR_INPUT_MRL_DEFAULT "v4l://"
# define VLVC_VAR_VIDEO_DEVICE_DEFAULT "/dev/video0"
# define VLVC_VAR_AUDIO_DEVICE_DEFAULT "/dev/dsp"
#endif
#define VLVC_VAR_USERNAME_DEFAULT ""
#define VLVC_VAR_DESCRIPTION_DEFAULT ""
#define VLVC_VAR_PASSWORD_DEFAULT ""
#define VLVC_VAR_VCODEC_DEFAULT 5
#define VLVC_VAR_ACODEC_DEFAULT 0
#define VLVC_VAR_VBITRATE_DEFAULT 9
#define VLVC_VAR_ABITRATE_DEFAULT 5
#define VLVC_VAR_CONFERENCE_MODE_DEFAULT 0
#define VLVC_VAR_NETWORK_PROTOCOL_DEFAULT 0
#define VLVC_VAR_VIDEO_CAPTURE_SIZE_DEFAULT 0
#define VLVC_VAR_VIDEO_SCALE_DEFAULT 2
#define VLVC_VAR_BUFFER_LEVEL_DEFAULT 1
#define VLVC_VAR_FORCE_CODECS_DEFAULT VLC_FALSE
#define VLVC_VAR_MULTICAST_MODE_DEFAULT VLC_TRUE

/***********************
 * Advanced parameters *
 ***********************/

#define VLVC_ADVANCED_SERVER_MODE VLC_FALSE
#define VLVC_ADVANCED_STANDALONE_MODE VLC_TRUE
#define VLVC_ADVANCED_IP VLC_FALSE
#define VLVC_ADVANCED_PORT VLC_TRUE
#define VLVC_ADVANCED_FIRST_CLIENT_PORT VLC_TRUE
#define VLVC_ADVANCED_INPUT_MRL VLC_TRUE
#define VLVC_ADVANCED_VIDEO_DEVICE VLC_TRUE
#define VLVC_ADVANCED_AUDIO_DEVICE VLC_TRUE
#define VLVC_ADVANCED_USERNAME VLC_FALSE
#define VLVC_ADVANCED_DESCRIPTION VLC_FALSE
#define VLVC_ADVANCED_VCODEC VLC_TRUE
#define VLVC_ADVANCED_VBITRATE VLC_TRUE
#define VLVC_ADVANCED_ACODEC VLC_TRUE
#define VLVC_ADVANCED_ABITRATE VLC_TRUE
#define VLVC_ADVANCED_CONFERENCE_MODE VLC_FALSE
#define VLVC_ADVANCED_NETWORK_PROTOCOL VLC_TRUE
#define VLVC_ADVANCED_VIDEO_CAPTURE_SIZE VLC_TRUE
#define VLVC_ADVANCED_VIDEO_SCALE VLC_TRUE
#define VLVC_ADVANCED_BUFFER_LEVEL VLC_TRUE
#define VLVC_ADVANCED_FORCE_CODECS VLC_TRUE
#define VLVC_ADVANCED_FIX_OVERLAY VLC_TRUE
#define VLVC_ADVANCED_PASSWORD VLC_FALSE
#define VLVC_ADVANCED_MULTICAST_MODE VLC_TRUE

/*************************
 * Module specific stuff *
 *************************/

#define VLVC_MODULE_SHORTNAME "VLVC"
#define VLVC_MODULE_DESCRIPTION "Video Conference Access Module"
#define VLVC_MODULE_SHORTCUT "vlvc"
#define VLVC_MODULE_CAPABILITY "access2"

/***********************
 * Combo boxes content *
 ***********************/

static int i_vcodec_list[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };

static char *psz_vcodec_list[] = { "mp1v", "mp2v", "mp4v", "DIV1", "DIV2",
                                   "DIV3", "H263", "h264", "WMV1", "WMV2",
                                   "MJPG", "theo" };

static int i_acodec_list[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };

static char *psz_acodec_list[] = { "mpga", "mp2a", "mp3", "mp4a", "a52", "vorb",
                                   "flac", "spx", "s16l", "fl32" };


static int i_vbitrate_list[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
static char *psz_vbitrate_list_text[] = { "3072", "2048", "1024",
                                          "768", "512", "384",
                                          "256", "192", "128",
                                          "96", "64", "32",
                                          "16" };
static int psz_vbitrate_list[] = { 3072, 2048, 1024, 768, 512,
                                   384, 256, 192, 128, 96, 64,
                                   32, 16 };

static int i_abitrate_list[] = { 0, 1, 2, 3, 4, 5, 6, 7 };
static char *psz_abitrate_list_text[] = { "512", "256", "192",
                                          "128", "96", "64",
                                          "32", "16" };
static int psz_abitrate_list[] = { 512, 256, 192, 128, 96, 64,
                                   32, 16 };

static int i_conference_mode_list[] = { VLVC_CONFERENCE_MODE_CHAT_ROOM,
                                        VLVC_CONFERENCE_MODE_CONFERENCE,
                                        VLVC_CONFERENCE_MODE_MEETING,
                                        VLVC_CONFERENCE_MODE_AMPHITHEATRE };
static char *psz_conference_mode_list_text[] = { VLVC_CONFERENCE_STRING_CHAT_ROOM,
                                                 VLVC_CONFERENCE_STRING_CONFERENCE,
                                                 VLVC_CONFERENCE_STRING_MEETING,
                                                 VLVC_CONFERENCE_STRING_AMPHITHEATRE };

static int i_network_protocol_list[] = { 0, 1 };

static char *psz_network_protocol_list[] = { "rtp", "udp" };

static int i_video_capture_size_list[] = { 0, 1, 2, 3, 4, 5 };
static char *psz_video_capture_size_list_text[] = { "320x240", "640x480",
                                                    "720x576", "800x600",
                                                    "1024x768", "2048x1536" };
static char *psz_video_capture_size_width_list[] = { "320", "640", "720", "800", "1024", "2048" };
static char *psz_video_capture_size_height_list[] = { "240", "480", "576", "600", "768", "1536" };

static int i_video_scale_list[] = { 0, 1, 2, 3 };
static char *psz_video_scale_list[] = { "0.25", "0.5", "0.75", "1" };

static int i_buffer_level_list[] = { 0, 1, 2, 3 };
static char *psz_buffer_level_list_text[] = { N_( "slow" ), N_( "default" ),
                                              N_( "fast" ), N_( "very fast" ) };

/* caching values: { i_video_input, i_udp_output, i_udp_input } */
static vlvc_caching_values_t caching_values[4] = { { 450, 450, 450 }, /* Slow */
                                                   { VLVC_IGNORE_VALUE, VLVC_IGNORE_VALUE, VLVC_IGNORE_VALUE }, /* Default */
                                                   { 200, 200, 200 }, /* Fast */
                                                   { 100, 100, 100 } }; /* Very fast */

/******************
 * Useful defines *
 ******************/
#define VLVC_DEFAULT_BIND_ADDRESS "0.0.0.0"
#define VLVC_DEFAULT_LOOPBACK_ADDRESS "127.0.0.1"
#define VLVC_DEFAULT_OUTPUT_MRL "#transcode{vcodec=%s,vb=%s,scale=0.75,acodec=%s,ab=%s,channels=2}:duplicate{dst=display,dst=std{access=udp,mux=ts,dst=%s:%%d}}"

#define VLVC_IDX_OPT_VDEV 0
#define VLVC_IDX_OPT_ADEV ( VLVC_IDX_OPT_VDEV + 1 )

#if defined (WIN32)
# define VLVC_OPT_VDEV_BASE "dshow-vdev=%s"
# define VLVC_OPT_ADEV_BASE "dshow-adev=%s"
# define VLVC_DSHOW_SIZE_BASE "dshow-size=%sx%s"
# define VLVC_IDX_OPT_SIZE ( VLVC_IDX_OPT_ADEV + 1 )
# define VLVC_IDX_OPT_END ( VLVC_IDX_OPT_SIZE + 1 )
# define VLVC_NB_INPUT_OPTION ( VLVC_IDX_OPT_END + 1 )
#else
# define VLVC_OPT_VDEV_BASE "v4l-vdev=%s"
# define VLVC_OPT_ADEV_BASE "v4l-adev=%s"
# define VLVC_V4L_WIDTH_BASE "v4l-width=%s"
# define VLVC_V4L_HEIGHT_BASE "v4l-height=%s"
# define VLVC_IDX_OPT_WIDTH ( VLVC_IDX_OPT_ADEV + 1 )
# define VLVC_IDX_OPT_HEIGHT ( VLVC_IDX_OPT_WIDTH + 1 )
# define VLVC_IDX_OPT_END ( VLVC_IDX_OPT_HEIGHT + 1 )
# define VLVC_NB_INPUT_OPTION ( VLVC_IDX_OPT_END + 1 )
#endif

static int  Open( vlc_object_t * );
static void Close( vlc_object_t * );
